/* --------------------------------------------------------------------------
** 	Primo programma di esempio per "abC dei PIC 18F"
**	Scritto in C18 utilizza lo schema riportato in 16F2620_4LED.sch utilizza
**	il PIC 18F2640 a 40MHz
** 
**	File  : prog001.c	Ver.: 0.0.1	- Creato: 03/05/08	Modificato: 03/05/08
**	
**	Autore: Roberto D'Amico (bobboteck(at)gmail.com)
**
**	Dipendenze: p18F4620.h
**				delays.h
**
**	Porte usate:
**	PORTA bit 0 (OUT) LED 1
**	PORTA bit 1 (OUT) LED 2
**	PORTA bit 2 (OUT) LED 3
**	PORTA bit 3 (OUT) LED 4
**
**	NOTE
**	
**
** ----------------------------------------------------------------------- */
#include <p18F2620.h>
#include <delays.h>
/*===========================================================================*/
/*====                        DEFINIZIONE PRAGMA                         ====*/
/*===========================================================================*/
#pragma config OSC	= HSPLL		// Usare con quarzo da 10MHz e PPL 4x
#pragma config FCMEN= OFF		// File-Safe clock monitor
#pragma config IESO	= OFF		// Internal External OSC SwitchOver
#pragma config PWRT	= ON		// Power Up timer
#pragma config BOREN= OFF		// Brown Out reset
#pragma config BORV	= 0			// Brown Out voltage
#pragma config WDT	= OFF		// WhatchDog timer
#pragma config WDTPS= 1			// WhatchDog postscaler
#pragma config MCLRE= ON		// MCLR enable
#pragma config LPT1OSC	= OFF	// T1 Oscillator enable
#pragma config PBADEN	= OFF	// PORTB A/D enable
#pragma config CCP2MX	= PORTC	// CCP2 Multiplex with RB3 or RC1
#pragma config STVREN	= ON	// Stack Overflow reset
#pragma config LVP	= OFF		// Low Voltage ICSP
#pragma config XINST= OFF		//
#pragma config DEBUG= OFF		// Background Debugger enable
#pragma config CP0	= OFF		// Code Protection Block 0
#pragma config CP1	= OFF
#pragma config CP2	= OFF
#pragma config CP3	= OFF
#pragma config CPB	= OFF		// Boot Block
#pragma config CPD	= OFF		// Data EEPROM
#pragma config WRT0	= OFF		// Write Protection
#pragma config WRT1	= OFF
#pragma config WRT2 = OFF
#pragma config WRT3 = OFF
#pragma config WRTB = OFF		// Boot Block
#pragma config WRTC	= OFF		// Configuration Register
#pragma config WRTD	= OFF		// Data EEPROM
#pragma config EBTR0= OFF		// Table Read protection Block 0
#pragma config EBTR1= OFF
#pragma config EBTR2= OFF
#pragma config EBTR3= OFF
#pragma config EBTRB= OFF		// Boot Block Table Read protection
/*===========================================================================*/
/*====                              DEFINE                               ====*/
/*===========================================================================*/
#define LED_1	LATAbits.LATA0
#define LED_2	LATAbits.LATA1
#define LED_3	LATAbits.LATA2
#define LED_4	LATAbits.LATA3
/*===========================================================================*/
/*====                               MAIN                                ====*/
/*===========================================================================*/
void main(void)
{
unsigned char counter;

	// Impostazione dei registri di configurazione del PIC
	ADCON1=0b00001111;
	CMCON=0b00000111;
	// Reset iniziale delle porte
	PORTA=0;
	PORTB=0;
	PORTC=0;
	// Definizione della funzione delle singole porte
	TRISA=0x00;
	TRISB=0x00;
	TRISC=0x00;
	
	// Accende il primo LED
	LED_1=1;
	Delay10KTCYx(250);
	// Loop infinito
	for(;;)
	{
		// Cicla per eseguire lo shift a sinistra del bit/LED
		for(counter=0;counter<3;counter++)
		{
			LATA=LATA<<1;
			Delay10KTCYx(250);
		}
		// Cicla per eseguire lo shift a destra del bit/LED
		for(counter=0;counter<3;counter++)
		{
			LATA=LATA>>1;
			Delay10KTCYx(250);
		}
	}
}
